#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include "../include/t100_oblist.h"
#include "../macro/t100.m"
#include "../include/t100_block1.h"

int tfnwrite(char * p_lpsz_filename, void * p_lp_buffer,int int_size) {
	int result;
	FILE * myfile;
	myfile = fopen(p_lpsz_filename,"w");
	if(!myfile) return 0;
	result = fwrite(p_lp_buffer,1,int_size,myfile);
	fclose(myfile);
	return result;	
}
		
void tmaketbuf(TBUF * lp_tbuf,void * lp_buffer,int int_buflen,int int_datalen,int int_reserve) {
	lp_tbuf->lp_buffer = (char *) lp_buffer; 
	lp_tbuf->int_buflen = int_buflen; 
	lp_tbuf->int_datalen = int_datalen; 
	lp_tbuf->int_reserve = int_reserve;
	lp_tbuf->int_currentreadposition = 0;
}

int tvread(TBUF * p_lp_tbuf_buffer,char * p_lpsz_bufferto,int p_int_buffersize,int p_int_size) {
	TBUF * t;
	t = p_lp_tbuf_buffer;
	if(p_int_size > p_int_buffersize) return 0;
	if(!t || !p_lpsz_bufferto || !p_int_size) return 0;
	if((t->int_datalen - t->int_currentreadposition) > p_int_size) return 0;
	memcpy(p_lpsz_bufferto,t->lp_buffer + t->int_currentreadposition,p_int_size);
	return p_int_size;
}

int tvgets(TBUF * p_lp_tbuf_buffer,char * p_lpsz_bufferto,int p_int_buffertosize) {
	char * forany;
	char * readposition;
	int int_len;
	if((!p_lp_tbuf_buffer) || (!p_lpsz_bufferto)) return 0;

	readposition = p_lp_tbuf_buffer->lp_buffer + p_lp_tbuf_buffer->int_currentreadposition;
	forany = strchr(readposition,'\n');
	if(!forany) return 0;
	int_len = forany - readposition;
	int_len++;
	if((int_len+1) > p_int_buffertosize) return 0;
	strncpy(p_lpsz_bufferto,readposition,int_len);
	p_lpsz_bufferto[int_len] = 0;	
	p_lp_tbuf_buffer->int_currentreadposition += int_len;
	return int_len;
}

int tvwrite(char * p_lp_newdata,int p_int_newdatasize, TBUF * p_lp_tbuf_buffer) {
	struct TBUF * t;
	char * lp_newbuf;
	int int_newbuflen;
	
	t = p_lp_tbuf_buffer;
	if((t->int_buflen - t->int_datalen) > p_int_newdatasize) {
		memcpy(&t->lp_buffer[t->int_datalen],p_lp_newdata,p_int_newdatasize);
		t->int_datalen += p_int_newdatasize;
	}
	else {
		int_newbuflen = t->int_datalen + p_int_newdatasize + t->int_reserve;
		lp_newbuf = (char *) malloc(int_newbuflen);
		bzero(lp_newbuf,int_newbuflen);
		if(lp_newbuf == 0) return 1;
		memcpy(lp_newbuf,t->lp_buffer,t->int_datalen);
		memcpy(&lp_newbuf[t->int_datalen],p_lp_newdata,p_int_newdatasize);
		free(t->lp_buffer);
		t->int_buflen = int_newbuflen;
		t->int_datalen += p_int_newdatasize;
		t->lp_buffer = lp_newbuf;
	}
	return 0;
}


//*************************************************************************
int gethostbyname(const char * lpsz_hostname,struct in_addr * address) {
	hostent * hostent_hostent;
	if((lpsz_hostname == 0) | (address == 0)) return -1;
	
	hostent_hostent = gethostbyname(lpsz_hostname);
	if(!hostent_hostent) { return -1; }
	*address = *((in_addr *) &hostent_hostent->h_addr_list[0][0]);
	endhostent();
	return 0;
}

//**************************************************************************
char * getnamebyhost(struct in_addr * params) {
	struct sockaddr_in address;
	struct hostent * hostent_hostent;

	if(!params) return 0;
	address.sin_addr = *params;
	hostent_hostent = gethostbyaddr((const char *) &address.sin_addr, 4,PF_INET);
	if(!hostent_hostent) return 0;
	return hostent_hostent->h_name;
}

//**************************************************************************
int inttostr(int i,char * buffer,int int_len) {
	int a,b;
	a = 1; b = i;
	
	while((i /= 10) >= 1) a++;
	if(int_len < (a+1)) return 0;
	buffer[a] = 0;
	i = b; b = a;
	while(--a >= 0) { buffer[a] = '0' + i%10; i /= 10; }
	printf("%s\n",buffer);
	return ++b;
}

//**************************************************************************
// lpsz_string =~ m/param1(.*)param2/
char * strmid(char * lpsz_string,char * param1, char * param2) {
	char * Result,*forany,*forany2;
	int int_strsize;
	if(!strlen(param1)) return 0;
	forany = strstr(lpsz_string,param1);
	if(!forany) return 0;
	forany += strlen(param1);
	forany2 = strstr(forany,param2);
	if(!forany2) return 0;
	int_strsize = forany2 - forany;
	printf("%d\n",int_strsize);
	fflush(stdout);
	if(!int_strsize) return 0;
	
	Result = (char *) malloc(int_strsize + 1);
	memcpy(Result,forany,int_strsize);
	Result[int_strsize] = 0;
	return Result;
}

//**************************************************************************
int split(char * lpsz_String,char * ch, char ** outbuffer,int int_buffersize) {
	char * forany;
	int i;
	i = 1;
	int_buffersize--;
	if(!lpsz_String) return 0;
	
	if(int_buffersize > 0) {
		forany = lpsz_String;
		outbuffer[0] = forany;
	}
	else {
		return 0;
	}
	forany = strstr(forany,ch);
	while(forany && (int_buffersize--)) {
		forany[0] = 0;
		forany++;
		outbuffer[i] = forany;
		forany = strstr(forany,ch);
		i++;
	}
	return i;
} 

//**************************************************************************
int t100_readdir(char * lpsz_dirname,T100ObjectsList * oblist_output,char fl_subdir,int umask) {
	char buffer[512];
	dirent * dirent_dirent;
	DIR * directory;
	
	if(!lpsz_dirname) return 1;
	directory = opendir(lpsz_dirname);
	
	if(!directory) { perror(""); return 1; }
	dirent_dirent = readdir(directory);
	while(dirent_dirent) {
		if((dirent_dirent->d_type == DT_DIR) && fl_subdir) {
			if((ne(dirent_dirent->d_name,".")) && (ne(dirent_dirent->d_name,".."))) {
				bzero(buffer,512);
				STRADD(lpsz_dirname);
				STRADD("/");
				STRADD(dirent_dirent->d_name);
				if(umask & DT_DIR) oblist_output->Add(strdup(buffer));
				t100_readdir(buffer,oblist_output,1,DT_REG);
			}
		}
		else if(dirent_dirent->d_type & umask) {
			bzero(buffer,512);
			STRADD(lpsz_dirname);
			STRADD("/");
			STRADD(dirent_dirent->d_name);
			oblist_output->Add(strdup(buffer));
		}
		dirent_dirent = readdir(directory);
	}
	closedir(directory);
	oblist_output->First();
	return 0;
}
