#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../include/t100_oblist.h"
#include "../include/t100_hash.h"
#include "../include/t100_block1.h"
#include "../include/global.h"
#include "../macro/t100.m"

char * T100Hash::Key(const char * p_lpsz_key) {
	char * forany;
	forany = (char *) oblist_key.First();
	oblist_strings.First();
	while(forany) {
		if(!strcmp(forany,p_lpsz_key)) {
			return (char *) oblist_strings.Current();
		}
		forany = (char *) oblist_key.Next();
		oblist_strings.Next();
	}
	return 0;
} 

int T100Hash::ReadFromFile(const char * lpsz_filename) {
	int i;
	FILE * myfile;
	char buffer[256];
	char * splitter[2];
	i = 0;
	// Open file
	myfile = fopen(lpsz_filename,"r");
	if(myfile == 0) {
#if DEBUG == 1
		perror("T100Hash::ReadFromFile line 29");
#endif
		return 0;
	}
	
	// Read file
	while(fgets(buffer,255,myfile) && (i < 256)) {
		chop(buffer);
		if(split(buffer,"=",splitter,2) != 2) {
#if DEBUG == 1
			printf("T100Hash::ReadFromFile line 39: Cat't split\n");
#endif
			break;
		}
		oblist_key.Add(strdup(splitter[0]));
		oblist_strings.Add(strdup(splitter[1]));	   
		i++;
	}
	int_size = i;
	fclose(myfile);
	return 1;
}

void T100Hash::Free() {
	int i;
	for(i = 0; i < int_size; i++) {
		free(oblist_key.Delete());
		free(oblist_strings.Delete());
	}
	int_size = 0;
}

char * T100Hash::Add(const char * lpsz_key, const char * lpsz_string) {
	if(Key(lpsz_key) != 0) return 0;
	oblist_key.Add(strdup(lpsz_key));
	oblist_strings.Add((void *) lpsz_string);
	int_size++;
	return (char *) oblist_strings.Current();
}

T100ObjectsList * T100Hash::GetKeys() {
	oblist_key.First();
	return &oblist_key;
}

T100ObjectsList * T100Hash::GetStrings() {
	oblist_strings.First();
	return &oblist_strings;
}

char * T100Hash::Delete(const char * lpsz_key) {
	char * forany;
	if(int_size == 0) return 0;
	int_size--;
	forany = (char *) oblist_key.First();
	oblist_strings.First();
	while(forany) {
		if(!strcmp(forany,lpsz_key)) {
			oblist_key.Delete();
			forany = (char *) oblist_strings.Delete();
			return forany;
		}
		forany = (char *) oblist_key.Next();
		oblist_strings.Next();
	}
	return 0;
}

void T100Hash::FreeStructure() {
	int i;
	for(i = 0; i < int_size; i++) {
		free(oblist_key.Delete());
		oblist_strings.Delete();
	}
	int_size = 0;
}

