#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../include/t100_oblist.h"
#include "../include/t100_hash.h"
#include "../macro/t100.m"
#include "../include/global.h"
#include "../include/t100_block1.h"
#include "../include/t100_mainexternals.h"
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include <dirent.h>
#include <signal.h>

//*****************************************************************
int t100portscanner(char * params) {
	sockaddr_in address_server;
	int port,sock;

	if(!params) return -1;
	port = 0;
	address_server.sin_family = AF_INET;
	inet_aton(params,&address_server.sin_addr);

	for(port = 0; port < 65536; port++) {
		sock = socket(AF_INET,SOCK_STREAM,0);
		address_server.sin_port = htons(port);
		if(0 > connect(sock,(sockaddr *) &address_server,sizeof(address_server))) {
			printf("Not connected to port %d\n",port);
		}
		else { printf("Connected to port %d !\n",port); sleep(3); }
		close(sock);
	}
	return 0;
}

//*****************************************************************
int t100gethostbyname(char * params) {
	sockaddr_in address;
	hostent * hostent_hostent;
	int i;

	printf("%s --- ",params);
	hostent_hostent = gethostbyname(params);
	if(!hostent_hostent) { perror(""); return 1; }
	
	i = 0;
	while(*((int *) &hostent_hostent->h_addr_list[i])) {
		address.sin_addr = *((in_addr *) &hostent_hostent->h_addr_list[i][0]);
		printf("%s\n",inet_ntoa(address.sin_addr));
		endhostent();
		i++;
	}
  return 0;
}

#ifdef USE_FORK
//******************************************************************
int t100connect(char * params) {
	int sock,int_size;
	sockaddr_in name,address_client;
	char buffer[1024];
	int splitresult;
	char * splitter[3];
	TBUF tbuf_sendbuf;
	int pid;
	int a,i;
	char * forany;
	unsigned char ResultType,fl_StringRequest;
	FILE * myfile;
	
	ResultType = 0;
	fl_StringRequest = 0;
	
	forany = hash_variables.Key("connect.ResultType");
	if(forany) {
		if(eq(forany,"smtp")) {
			ResultType = 1;
		}
	}
	
	tmaketbuf(&tbuf_sendbuf,0,0,0,256);
	bzero(buffer,1024);
	sock = socket(PF_INET,SOCK_STREAM,0);
	splitresult = split(params," ",splitter,3);
	if(splitresult < 2) { printf("NULL\n"); return -1; }
	if(eq(splitter[0],"-n")) {
		printf("%s\n",splitter[0]);
		if(gethostbyname(splitter[1],&name.sin_addr) == -1) {
			printf("Unknown host !\n");
		}
		name.sin_port = htons(atoi(splitter[2]));
	}
	else if(eq(splitter[0],"-h")) {
		splitresult = split(splitter[1],":",splitter,2);
		name.sin_port = htons(atoi(splitter[1]));
		inet_aton(splitter[0],&name.sin_addr);
	}
	else return -1;
	
	name.sin_family = AF_INET;
	address_client.sin_family = AF_INET;
	address_client.sin_port = 0;
	*((int *) &address_client.sin_addr) = 0;
	
	printf("%s:%d\n",inet_ntoa(name.sin_addr),htons(name.sin_port));
	if(connect(sock,(sockaddr *) &name,sizeof(name)) < 0) { printf("Not connected !\n"); return 1; }
	bzero(buffer,256);

	if((pid = fork()) && (pid > 0)) {
t100connectlabel1:
		while(fgets(buffer,256,MYINPUT)) {
			if(eq(buffer,".connect.close\n")) {
				printf(".connect.close OK\n");
				shutdown(sock,SHUT_RDWR);
				close(sock);
				break;
			}
	
			if(eq(buffer,".connect.strings\n")) {
				fl_StringRequest = 1;
				continue;
			}
			
			if(eq(buffer,".connect.notrecv\n")) {
				kill(pid,SIGHUP);
			}

			if(!strncmp(buffer,".connect.sendfile ",18)) {
				chop(buffer);
				myfile = fopen(&buffer[18],"r");
				if(myfile == 0) { perror("fopen"); continue; }
				while((i = fread(buffer,1,1024,myfile)) && (i > 0)) {
					send(sock,buffer,i,0);
				}
				fclose(myfile);
				printf("Send complete !\n");
				continue;
			}
			
			if(fl_StringRequest > 0) {
				send(sock,buffer,strlen(buffer),0);
				continue;
			}
			
			if(strncmp(buffer,"\\.\\",3)) { 
				chop(buffer);
				STRADD("\r\n");
				tvwrite(buffer,strlen(buffer),&tbuf_sendbuf);
			}
			else { 
				forany = strstr(buffer," ");
				if(forany) i = atoi(++forany); else i = 1;
				for(a = 0; a < i; a++) {
					send(sock,tbuf_sendbuf.lp_buffer,tbuf_sendbuf.int_datalen,0);
				}
				free(tbuf_sendbuf.lp_buffer);
				tmaketbuf(&tbuf_sendbuf,0,0,0,256);
			}
		}
		if(MYINPUT != stdin) {
			fclose(MYINPUT); MYINPUT = stdin;
			goto t100connectlabel1;
		}
		
	}
	else {
		bzero(buffer,256);
		while((int_size = recv(sock,buffer,255,MSG_DONTWAIT)) && (int_size != 0)) {
			if(int_size > 0) {
				if(ResultType == 0) {
					printf(buffer);
				}
				else if(ResultType == 1) { // SMTP
					forany = strchr(buffer,' ');
					if(forany) {
						forany[0] = 0;
						printf("%s\n",buffer);
					}
				}
			}
			bzero(buffer,256);
			sleep(1);
		}
		printf("Recv process stoped !\n");
	}
	return 0;
}
#else

int t100connect(char * params) {
	printf(",      .\n");
	return 0;	
}

#endif

//**************************************************************************
int t100getnamebyhost(char * params) {
	sockaddr_in address;
	hostent * hostent_hostent;
	int i;
	
	if(!params) return -1;
	inet_aton(params,&address.sin_addr);
	hostent_hostent = gethostbyaddr((const char *) &address.sin_addr, 4,PF_INET);
	if(!hostent_hostent) { printf("NULL"); return -1; }
	i = 0;
	while(*((int *) &hostent_hostent->h_addr_list[i])) {
		address.sin_addr = *((in_addr *) &hostent_hostent->h_addr_list[i][0]);
		printf("%s --- %s\n",inet_ntoa(address.sin_addr),hostent_hostent->h_name);
		i++;
	}
	endhostent();
	return 0;
}

//*****************************************************************
int t100getnamesbynetmask(char * params) {
	unsigned char IP[4];
	char * splitter[4];
	int splitresult;
	char buffer[256];
	char * forany;
	
	if(!params) return -1;
	bzero(buffer,256);
	STRADD(params);  
  
	splitresult = split(buffer,".",splitter,4);
	if(splitresult != 3) { printf("use \".getnamesbynetmask xxx.xxx.xxx\"\n"); return -1; }
	IP[0] = atoi(splitter[0]);
	IP[1] = atoi(splitter[1]);
	IP[2] = atoi(splitter[2]);
	IP[3] = 1;
	
	while(IP[3]++ < 255) {
		forany = getnamebyhost((in_addr*)IP);
		if(forany) {
			printf("%d.%d.%d.%d - %s\n",IP[0],IP[1],IP[2],IP[3],forany);
		}
		else {
			printf("%d.%d.%d.%d - NULL\n",IP[0],IP[1],IP[2],IP[3]);
		}
	}
	return 0;
}

//*****************************************************************
int t100proxy(char * params) {
	sockaddr_in address_server,address_realserver;
	char buffer[256],inputbuffer[1025],outputbuffer[1025];
	char * splitter[3];
	int splitresult,int_size;
	int sock_client,sock_server,sock_realserver;
		
	if(fork()) return 0;  
	bzero(buffer,256);
	bzero(inputbuffer,1025); bzero(outputbuffer,1025);
	STRADD(params);
	sock_server = socket(AF_INET,SOCK_STREAM,0);
	
	if(!params) return -1;
	splitresult = split(buffer," ",splitter,3);
	
	inet_aton("127.0.0.1",&address_server.sin_addr);
	address_server.sin_family = AF_INET;
	address_server.sin_port = htons(atoi(splitter[0]));
	
	if(0 > bind(sock_server,(sockaddr *)&address_server,sizeof(address_server)))
	{ perror("bind"); exit(0); }

	listen(sock_server,5);
	sock_client = accept(sock_server,0,0);
	
	while(sock_client > 0) {
		if(fork()) {
			close(sock_client);
			sock_client = accept(sock_server,0,0); 
			continue;
		}
		printf("Accepted to proxy. Port %s\n",splitter[0]);
		bzero(&address_realserver,sizeof(address_realserver));
		sock_realserver = socket(AF_INET,SOCK_STREAM,0);
		inet_aton(splitter[1],&address_realserver.sin_addr);
		address_realserver.sin_family = AF_INET;
		address_realserver.sin_port = htons(atoi(splitter[2])); 
		if(0 > connect(sock_realserver,(sockaddr*) &address_realserver,sizeof(address_realserver))) {
			perror("connect"); goto ProxyExit; }
		
		if(fork()) {
			int_size = recv(sock_client,inputbuffer,1024,MSG_DONTWAIT);
			printf(inputbuffer);
			if(int_size == 0) { perror("recv"); goto ProxyExit; }      
			
			while(1) {
				if(int_size > 0) {
					printf("Recv from client %d\n",int_size);
					send(sock_realserver,inputbuffer,int_size,0);
					printf(inputbuffer);
					bzero(inputbuffer,1025);
				}
				int_size = recv(sock_client,inputbuffer,1024,MSG_DONTWAIT);
				sleep(1);
			}
			printf("End receive !\n");
		}
		else {
			int_size = recv(sock_realserver,inputbuffer,1024,MSG_DONTWAIT);
			printf(inputbuffer);
			if(int_size == 0) { perror("recv"); goto ProxyExit; }
			// printf("Start recv from real server !\n");
			while(1) {
				if(int_size > 0) {
					send(sock_client,inputbuffer,int_size,0);
					printf(inputbuffer);
					bzero(inputbuffer,1025);          
				}
				sleep(1);
				int_size = recv(sock_realserver,inputbuffer,1024,MSG_DONTWAIT);        
			}
		}
		
ProxyExit:
		close(sock_client);
		close(sock_realserver);
		close(sock_server);
		printf("Connection closed !\n");
		exit(0);
	}
	exit(0);  
	return 0;
}


//**************************************************************************
int t100dgram_recv(char * params) {
	int sock;
	sockaddr_in address;
	char buffer[1024];
	char * splitter[2];
	int splitresult;
	size_t int_addresssize;

	if(!params) return -1;
	bzero(buffer,1024);
	bzero(&address,sizeof(address));
	strncpy(buffer,params,1023);
	
	splitresult = split(buffer,":",splitter,2);
	if(splitresult < 2) { printf("NULL\n"); return -1; }
	address.sin_port = htons(atoi(splitter[1]));
	inet_aton(splitter[0],&address.sin_addr);

	address.sin_family = AF_INET;
	int_addresssize = sizeof(address);
	sock = socket(PF_INET,SOCK_DGRAM,0);
	if(sock < 0) perror("");
	if(0 > bind(sock,(sockaddr *) &address,sizeof(address))) {
		perror("");
	}
	bzero(buffer,1024);
	recvfrom(sock,buffer,1023,0,0,0);
	printf(buffer);
	return 0;
}

//**************************************************************************
int t100dgram_send(char * params) {
	int sock;
	sockaddr_in address;
	TBUF tbuf_dgram;
	char buffer[1024];
	char * splitter[2];
	int splitresult;
	
	if(!params) return -1;
	tmaketbuf(&tbuf_dgram,0,0,0,2048);
	bzero(buffer,1024);
	bzero(&address,sizeof(address));
	strncpy(buffer,params,1023);
	
	splitresult = split(buffer,":",splitter,2);
	if(splitresult < 2) { printf("NULL\n"); return -1; }
	address.sin_port = htons(atoi(splitter[1]));
	inet_aton(splitter[0],&address.sin_addr);
	address.sin_family = AF_INET;

	sock = socket(AF_INET,SOCK_DGRAM,0);
	while((fgets(buffer,1023,stdin)) && (ne(buffer,"\\.\\\n"))) {
		tvwrite(buffer,strlen(buffer),&tbuf_dgram);
	}
	if(0 > sendto(sock,tbuf_dgram.lp_buffer,tbuf_dgram.int_datalen,0,
				(sockaddr *) &address,sizeof(address))) perror("");
	return 0;
}

//**************************************************************************
int t100portfinder(char * params) {
	unsigned char IP[4];
	char * splitter[4];
	int splitresult;
	char buffer[256];
	char * forany;
	const char * lpsz_usage = "usege : \".portfinder xxx.xxx.xxx <port>\"\n";
	int sock;
	struct sockaddr_in address;
	
	if(!params) { printf(lpsz_usage); return -1; }
	bzero(buffer,256);
	STRADD(params);  
	forany = strchr(buffer,' ');
	if(!forany) { printf(lpsz_usage); return -1; }
	forany[0] = 0; forany ++;
	address.sin_family = AF_INET;
	address.sin_port = htons(atoi(forany));
	printf("%s\n",forany);
	sock = socket(AF_INET,SOCK_STREAM,0);
	
	splitresult = split(buffer,".",splitter,4);
	if(splitresult != 3) { printf(lpsz_usage); return -1; }
	IP[0] = atoi(splitter[0]);
	IP[1] = atoi(splitter[1]);
	IP[2] = atoi(splitter[2]);
	IP[3] = 0;
	
	while(IP[3]++ < 255) {
		*((unsigned int *) &address.sin_addr) = *((unsigned int*) IP);
		if(connect(sock,(struct sockaddr *) &address,sizeof(address)) >= 0) {
			printf("ok %d.%d.%d.%d\n",IP[0],IP[1],IP[2],IP[3]);
			close(sock); sock = socket(AF_INET,SOCK_STREAM,0);
		}
	}
	return 0;
}
