#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../include/t100_oblist.h"
#include "../include/t100_hash.h"
#include "../macro/t100.m"
#include "../include/global.h"
#include "../include/t100_block1.h"
#include "../include/t100_daemons.h"
#include "../include/t100_mainexternals.h"
#include <unistd.h>
#include <dirent.h>
#include <signal.h>
#include <errno.h>
#include <fcntl.h>


//**************************************************************************
int t100daemonize(char * params) {
	daemon(1,0);
	t100input(params);	
	return 0;
}

//**************************************************************************
int t100hup(char * params) {
	char buffer[1024];

	bzero(buffer,1024);
	strcat(buffer,"t100 ");
	if(params) strcat(buffer,params);
	system(buffer);
	t100exit("");
	return 0;
}

//***************************************************************************
int t100dumpfile(char * params) {
	int fileno;
	char buffer[4097];
	int int_size;
	
	fileno = 0;
	fileno = open(params,O_RDONLY);
	if(!fileno) return -1;
	if(!params) return -1;
	while((int_size = read(fileno,buffer,4096)) && int_size) {
		buffer[int_size] = 0;
		printf("%s\n",buffer);
	}
	close(fileno);
	return 0;
}

//**************************************************************************
int t100intoout(char * params) {
	char buffer[256];

	while(fgets(buffer,255,MYINPUT)) {
		if(eq(buffer,".intoout.close\n")) break;
		printf(buffer);
	}
	return 0;
}

//**************************************************************************
int t100get(char * params) {
	char buffer[1024];

	if(hash_variables.Key(params)) hash_variables.Delete(params); 
	
	printf("%s : ",params);
	fgets(buffer,1024,stdin);
	chop(buffer);
	hash_variables.Add(params,buffer);
	printf("%s set to %s\n",params,buffer);
	return 0;
}

//**************************************************************************
int t100print(char * params) {
	if(!params) printf("\n");
	printf("%s\n",params);
	return 0;
}

//**************************************************************************
int t100rmvar(char * params) {
	hash_variables.Delete(params);
	return 0;
}

//**************************************************************************
int t100popen(char * params) {
	if(MYOUTPUT != stdout) fclose(MYOUTPUT);
	MYOUTPUT = popen(params,"w");
	dup2(fileno(MYOUTPUT),1);
	return 0;
}

//*************************************************************************
// NEW FILE
int t100newfile(char * params) {
	FILE * myfile,*myfile2;
	char buffer[256];

	memset(buffer,0,255);
	STRADD(hash_params.Key("CURRENTPROJECTDIR"));
	STRADD("block/");
	STRADD(hash_params.Key("CURRENTPROJECTNAME"));
	STRADD("_");
	STRADD(params);
	STRADD(".cpp");
#if DEBUG == 1
	printf("%s\n",buffer);
#endif
	myfile = fopen(buffer,"w");
	if(!myfile) { return 1; }
	myfile2 = fopen("newfile.std","r");
	if(!myfile) { return 1; }

	while(fgets(buffer,255,myfile2)) {
		fprintf(myfile,"%s",buffer);
	}
	fclose(myfile2);
	fclose(myfile);

	memset(buffer,0,255);
	STRADD(hash_params.Key("CURRENTPROJECTDIR"));
	STRADD("include/");
	STRADD(hash_params.Key("CURRENTPROJECTNAME"));
	STRADD("_");
	STRADD(params);
	STRADD(".h");
#if DEBUG == 1
	printf("%s\n",buffer);
#endif
	myfile = fopen(buffer,"w");
	fclose(myfile);
	return 0;
}

//*************************************************************************
int getexternals_nameonly(char * lpsz_filename,T100ObjectsList * oblist_output) {
	FILE *myfile;
	char buffer[256],fl_Correct,fl_Comment;
	char * forany,*forany2,*lpsz_skobka;
	int i,int_size;

	lpsz_skobka = 0;
	if(!lpsz_filename) return 1;
	myfile = fopen(lpsz_filename,"r");
	printf("%s\n",lpsz_filename);
	if(!myfile) { perror("T100"); return 1; }
#if DEBUG == 1
	printf("T100_Getexternals_Filename : %s\n",lpsz_filename);
#endif

	i = 0;
	fl_Comment = 0;
	while(fgets(buffer,255,myfile)) {
		i++;
		// Kill comment
		forany = strstr(buffer,"//"); if(forany) { forany[0] = 0; }
		forany = strstr(buffer,"/*");
		if(forany) {
			fl_Comment = 1;
			forany2 = strstr(buffer,"*/");
			if(!forany2) continue; //   .
			else {
				fl_Comment = 0;
				memset(forany,' ',forany2 - forany + 2);
			}
		}
		if(fl_Comment) {
			forany = strstr(buffer,"*/");
			if(!forany) continue; else {
				memset(buffer,' ',forany - buffer + 2);
				fl_Comment = 0;
			}
		}

		if(buffer[0] == '#') {
			while(strchr(buffer,'\\')) { fgets(buffer,255,myfile); i++; }
			continue;
		}
		if(strstr(buffer,"extern")) {
			if(strchr(buffer,';')) fl_Correct = 1; else fl_Correct = 0;
			forany = strchr(buffer,'(');
			lpsz_skobka = forany;
			if(forany) {
				forany[0] = 0;
				while((--forany)[0] == ' ');
				forany[1] = 0;  
				forany = buffer + strlen(buffer);
				while((forany != buffer) && (forany[0] != ' ') && (forany[0] != 9)) forany--;
						
				if(forany != buffer) forany++; else continue;
				if(forany[0] == '*') forany++;
				if(!strlen(forany)) continue;
				if(ne(forany,"__REDIRECT")) {
					int_size = strlen(forany);
					forany2 = (char *) malloc(int_size + 1 + 4*2);
					memcpy(forany2,forany,int_size+1);
					*((int *) &forany2[int_size + 1]) = i;
					//printf("%s\n",lpsz_filename);
					*((char **) &forany2[int_size + 5]) = lpsz_filename;
					oblist_output->Add(forany2);
				}
				else {
					// Redirect
					lpsz_skobka++;
					// lpsz_skobka - redirect from;
					forany = strchr(lpsz_skobka,',');
					if(forany) forany[0] = 0; else return 2;
					forany++;

					if(fl_Correct) {
						forany2 = strrchr(forany,')');
						if(forany2) forany2[0] = 0;
						forany = strrchr(forany,',');
						if(forany) forany++; else return 2;
						int_size = strlen(forany);
						forany2 = (char *) malloc(int_size + 1 + 4*2);
						if(!forany) perror("");
						memcpy(forany2,forany,int_size+1);
						*((int *) &forany2[int_size + 1]) = i;
						*((char **) &forany2[int_size + 5]) = lpsz_filename;
						//printf("%s -- redirect to -- %s line %d\n",lpsz_skobka,forany,i);
						oblist_output->Add(forany2);
					}
				}
				if(!fl_Correct) {
					while(!strchr(buffer,';')) {
						if(!fgets(buffer,255,myfile)) break;
						i++;
					}
				}
				else {
					continue;
				}
			}
		}
	}

	oblist_output->First();
	fclose(myfile);
	return 0;
}

//***************************************************************************************************
//  GET EXTERNALS
int t100getexternals(char * params) {
	T100ObjectsList temp,strlist,filelist;
	FILE *myfile;
	char buffer[256],fl_Correct,fl_Comment;
	char * forany,*forany2,*lpsz_skobka;
	int i;
	
	if(!params) return -1;
	lpsz_skobka = 0;
	
	if((!strncmp(params,"-t",2)) && (params[2] != 0)) {
		if(params[2] == '1') {
			getexternals_nameonly(params+4,&strlist);
			goto T100GetExternalsGood;
		}
		else if((params[2] == '2') || (params[2] == '3')) {
			if(params[2] == '2') t100_readdir(params+4,&filelist,0,DT_REG);
			else if(params[2] == '3') t100_readdir(params+4,&filelist,1,DT_REG);
			forany = (char *) filelist.First();
			while(forany) {
				temp.Free();
				getexternals_nameonly(forany,&temp);
				temp.Sort();
				forany = (char *) temp.First();

				while(forany) { strlist.Add((void *) forany); forany = (char *) temp.Next(); }
				forany = (char *) filelist.Next();
			}
#if DEBUG == 1
			printf("Success !\n");
#endif
			goto T100GetExternalsGood;
		}
	}
	else myfile = fopen(params,"r");
	if(!myfile) { perror("T100: "); return 1; }

	i = 0;
	fl_Comment = 0;
	while(fgets(buffer,255,myfile)) {
		i++;
		// Kill comment
		forany = strstr(buffer,"//"); if(forany) { forany[0] = 0; }
		forany = strstr(buffer,"/*");
		if(forany) {
			fl_Comment = 1;
			forany2 = strstr(buffer,"*/");
			if(!forany2) continue;
			else {
				fl_Comment = 0;
				memset(forany,' ',forany2 - forany + 2);
			}
		}
		if(fl_Comment) {
			forany = strstr(buffer,"*/");
			if(!forany) continue; else {
				memset(buffer,' ',forany - buffer + 2);
				fl_Comment = 0;
			}
		}
		if(buffer[0] == '#') {
			while(strchr(buffer,'\\')) { fgets(buffer,255,myfile); i++; }
			continue;
		}
		if(strchr(buffer,'(')) {
			if(strchr(buffer,';')) fl_Correct = 1; else fl_Correct = 0;
			// Full Dump
			printf("%s",&buffer[7]);
			while((!strchr(buffer,';')) && (fgets(buffer,255,myfile)) ) {
				printf("%s",buffer);
			}
		}
	}
	fclose(myfile);
T100GetExternalsGood:
	strlist.First();
	strlist.Sort(0);
	while((forany == (char *) strlist.Delete()) && forany) {
		printf("%s\t%s\t%d\n",forany,*((char **) &forany[strlen(forany) + 5]),
				*((int *) &forany[strlen(forany) + 1]));
		free(forany);
	}
	return 0;
}

// **************************************************************************************************
// TEST
int t100test(char * params) {
	char buffer[1024];
	int int_result;
	FILE * myfile;
	
	myfile = fopen(params,"r");
	while(fgets(buffer,1023,myfile)) {
		buffer[strlen(buffer) - 1] = 0;
		printf("\r%s",buffer);
		fflush(stdout);
		usleep(1000000);
		memset(buffer,' ',strlen(buffer));
		printf("\r%s",buffer);
		fflush(stdout);
	}
	fclose(myfile);
	return 0;
}

// **************************************************************************************************
// HELLO
int t100hello(char * params) {
	return 0;
}

// *****************************************************************************************************
int t100quit(char * params) {
	t100exit(" ");
	return 0;
}

//***************************************************************************************************
int t100convertto(char * params) {
	T100ObjectsList oblist_filelist;
	char buffer[256],buffer2[256];
	char * forany;
	int int_pathsize;
	FILE * file_from,*file_to;
	char * buf_path,*buf_topath;
	char fl_To;
	char * splitter[3];
	int splitresult;

	fl_To = 0;
	bzero(buffer2,256); strcat(buffer2,params);
	splitresult = split(buffer2," ",splitter,3);
	if(splitresult != 3) return -1;
	if(eq(splitter[0],"dos")) fl_To = 1;
	else if(eq(splitter[0],"unix")) fl_To = 2;
	else return -1;

	buf_path = splitter[1]; buf_topath = splitter[2];

	bzero(buffer,256);
	int_pathsize = strlen(buf_path);
	t100_readdir(buf_path,&oblist_filelist,1,DT_REG);
	STRADD("mkdir -p ");
	STRADD(buf_topath);
	system(buffer);

	forany = (char *) oblist_filelist.Current();
	while(forany) {
		printf("%s\n",forany);
		bzero(buffer,256);
		STRADD("mkdir -p ");
		STRADD(buf_topath); STRADD("/"); STRADD(forany + int_pathsize + 1);
		(strrchr(buffer,'/'))[0] = 0;
		system(buffer);

		bzero(buffer,256);
		STRADD(buf_topath); STRADD("/");
		STRADD(forany + int_pathsize + 1);

		file_from = fopen(forany,"r");
		printf("%s\n",buffer);
		file_to = fopen(buffer,"w");
		if(!(file_from && file_to)) return 0;
		if(fl_To == 1) {
			while(fgets(buffer,256,file_from)) {
				chop(buffer);
				STRADD("\r\n");
				fwrite(buffer,1,strlen(buffer),file_to);
			}
		}
		else { // To Unix
			while(fgets(buffer,256,file_from)) {
				chop(buffer); chop(buffer);
				STRADD("\n");
				fwrite(buffer,1,strlen(buffer),file_to);
			}
		}
		fclose(file_from);
		fclose(file_to);
		forany = (char *) oblist_filelist.Next();
	}
	return 0;
}

//***************************************************************************
int t100initdaemons(char * params) {
//	T100_Daemon_Coder();
	return 0;
}

//***************************************************************************
int t100sleep(char * params) {
	sleep(atoi(params));
	return 0;
}

//*****************************************************************
int t100pwd(char * params) {
	char buffer[256];

	bzero(buffer,256);
	if(getcwd(buffer,255)) {
		printf("%s\n",buffer);
	}
	return 0;
}

//*****************************************************************
int t100dir(char * params) {
	char buffer[256];
	T100ObjectsList oblist_filelist;
	char * forany;

	bzero(buffer,256);
	if(!params) getcwd(buffer,255);
	else STRADD(params);
	t100_readdir(buffer,&oblist_filelist,1,DT_DIR | DT_REG);
	while((forany = (char *) oblist_filelist.Delete()) && forany) {
		printf("%s\n",forany);
		free(forany);
	}
	
	return 0;
}

//*****************************************************************
int t100cd(char * params) {
	if(!params) return -1;
	chdir(params);
	return 0;
}

//*****************************************************************
int t100set(char * params) {
	int splitresult;
	char * splitter[2];
	char buffer[256];

	if(!params) return -1;
	bzero(buffer,256);
	STRADD(params);
	splitresult = split(buffer," ",splitter,2);
	if(splitresult < 2) return -1;
	if(hash_variables.Key(splitter[0]) != 0) {
		free(hash_variables.Delete(splitter[0]));
	}
	hash_variables.Add(splitter[0],strdup(splitter[1]));
	return 0;
}

//*****************************************************************
int t100fork(char * params) {
	if(params == 0) return -1;
	if(fork()) {
	}
	else {
		t100input(params);
	}
	return 0;
}

//*****************************************************************
int t100exit(char * params) {
	fclose(MYINPUT);
	return 0;
}

//*****************************************************************
int t100input(char * params) {
	char buffer[256];
	char * forany;
	bzero(buffer,256);
	if(!params) {
		if(MYINPUT != stdin) {
			fclose(MYINPUT);
			MYINPUT = stdin;
			return 0;
		}
		else return -1;
	}
	if(MYINPUT != stdin) fclose(MYINPUT);
	MYINPUT = fopen(params,"r");

	if(MYINPUT <= 0) {
		STRADD("../input/"); STRADD(params); STRADD(".txt");
		printf("%s\n",buffer);
		MYINPUT = fopen(buffer,"r");
	}

	if(MYINPUT == 0) { MYINPUT = stdin; return -1; }
	else {
		forany = hash_variables.Key("input.FileName");
		if(forany) hash_variables.Delete("input.Filename");
		hash_variables.Add("input.FileName",params);
	}
	return 0;
}

//*****************************************************************
int t100input_seektobegin(char * params) {
	if(MYINPUT != stdin) {
		fseek(MYINPUT,0,SEEK_SET);
	}
	else return -1;
	return 0;
}

//*****************************************************************
int t100output(char * params) {
	if(!params) {
		fclose(MYOUTPUT);
		dup2(fileno(oldoutput),1);
		return 0;
	}
	if(MYOUTPUT != stdout) fclose(MYOUTPUT);
	MYOUTPUT = fopen(params,"w");
	if(MYOUTPUT <= 0) { MYOUTPUT = stdout; return -1; }
	dup2(fileno(MYOUTPUT),1);
	return 0;
}

//*****************************************************************
int t100error(char * params) {
	if(!params) {
		fclose(MYERROR);
		dup2(fileno(olderror),2);
		return 0;
	}
	if(!params) return -1;
	if(MYERROR != stderr) fclose(MYERROR);
	MYERROR = fopen(params,"w");
	if(MYERROR <= 0) { MYERROR = stderr; return -1; }
	dup2(fileno(MYERROR),2);
	return 0;
}

