#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../macro/t100.m"
#include "../include/t100_oblist.h"

T100ObjectsList::T100ObjectsList() {
	lp_first = 0; lp_current = 0; lp_last = 0;
}

T100ObjectsList::~T100ObjectsList() {
}

void * T100ObjectsList::Add(void * lp_Object) {
	void ** lp_new;
	if(!lp_Object) return 0;
	lp_new = (void **) malloc(12); // This, prev, next;
	lp_new[0] = lp_Object;
	if(!lp_first) { 
		lp_new[1] = 0; lp_new[2] = 0;
		lp_first = lp_new; lp_last = lp_new;
		lp_current = lp_new;
	}
	else {
		lp_new[1] = lp_last;
		lp_new[2] = 0;
		lp_last[2] = lp_new;
		lp_last = lp_new;
		lp_current = lp_new;
	}
	return lp_Object;
}

void * T100ObjectsList::First() {
	if(lp_first) { lp_current = lp_first; return lp_first[0];} else return 0;
}

void * T100ObjectsList::Current() {
	if(lp_current) return lp_current[0]; else return 0;
}

void * T100ObjectsList::Next() {
	if(lp_current) {
		if(lp_current[2]) lp_current = (void **) lp_current[2]; else return 0;
		return lp_current[0];
	} else return 0;
}

void * T100ObjectsList::Prev() {
	if(lp_current) {
		if(lp_current[1]) lp_current = (void **) lp_current[1]; else return 0;
		return lp_current[0];
	} else return 0;
}

void * T100ObjectsList::Last() {
	if(lp_last) {
		lp_current = lp_last;
		return lp_last[0];
	} else return 0;
}

void * T100ObjectsList::Delete() {
	void * lp_object, **lp_killed;
	if(!lp_current) { 
#if DEBUG == 1
		printf("Current onject is null ! at T100ObjectsList::Delete() line 69\n");
#endif
		return 0;
	}
	lp_killed = lp_current; lp_object = lp_current[0];
	if(lp_killed[1] && lp_killed[2]) {
#if DEBUG == 1
		printf("Delete. Variant 1\n");
#endif
		lp_current = (void **) lp_killed[2];
		((void **) lp_killed[1])[2] = lp_killed[2];
		((void **) lp_killed[2])[1] = lp_killed[1];
	}
	else if(lp_killed[1]) {
		lp_current = (void **) lp_killed[1];
		lp_current[2] = 0;
		lp_last = lp_current;
	}
	else if(lp_killed[2]) {
		lp_current = (void **) lp_killed[2];
		lp_current[1] = 0;
		lp_first = lp_current;
	}
	else {
		lp_last = 0; lp_first = 0; lp_current = 0;
	}
	free(lp_killed);
	return lp_object;
}

int T100ObjectsList::Free() {
	int i;
	void *lp_killed,*lp_killed2;
	lp_killed = (void *) lp_first;
	i = 0;
	
	while(lp_killed) {
		lp_killed2 = ((void **)lp_killed)[2];
		free(lp_killed);
		lp_killed = lp_killed2;
		i++;
	}
	lp_first = 0; lp_current = 0; lp_last = 0;
	return i;
}

void * T100ObjectsList::Set(void * lp_Object) {
	void * lp_prev;
	if(!lp_current) return 0;
	lp_prev = lp_current[0];
	lp_current[0] = lp_Object;
	return lp_prev;
}

void * T100ObjectsList::SetPrev(void * lp_Object) {
	void * lp_prev;
	if(!lp_current) return 0;
	if(!lp_current[1]) return 0;
	lp_prev = lp_current[1];
	lp_current[1] = lp_Object;
	return lp_prev;
}

void * T100ObjectsList::SetNext(void * lp_Object) {
	void * lp_prev;
	if(!lp_current) return 0;
	if(!lp_current[2]) return 0;
	lp_prev = lp_current[2];
	lp_current[2] = lp_Object;
	return lp_prev;
}

int T100ObjectsList::Sort(char fl_FlagReverse) {
	char * forany,*forany2,fl_Flag;
	void * rev1;
#define SORT_REVERSE 1
#define SORT_FAST 2;
	
	forany = (char *) First();
	if(fl_FlagReverse) {
		fl_Flag = 1;
		while(fl_Flag == 1) {
			fl_Flag = 0;
			while(Next()) {
				if(strcmp(forany,((char **)lp_current)[0]) < 0) {
					rev1 = ((void **) lp_current[1])[0];
					((void **) lp_current[1])[0] = lp_current[0];
					lp_current[0] = rev1;
					
					forany = (char *) Current();
					fl_Flag = 1;
				} else forany = (char *) lp_current[0];
			}
		}
	}
	else {
		while(Next()) { 
			if(strcmp(forany,(char *) Current()) > 0) {
				rev1 = ((void **) lp_current[1])[0]; 
				((void **) lp_current[1])[0] = lp_current[0]; 
				lp_current[0] = rev1;
				forany = (char *) First();
			} else forany = (char *) lp_current[0]; 
			
		}
	}
	
	forany = (char *) First();
	fl_Flag = 1;
	while(fl_Flag) {
		fl_Flag = 0;
		while(forany) {
			forany2 = (char *) Next();
			if(!forany2) break;
			if(!strcmp(forany,forany2)) { fl_Flag = 1;	free(Delete()); }
			forany = (char *) Current();
		}
		forany = (char *) First();
	}
	
	First();
	return 0;
}


