#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../include/t100_oblist.h"
#include "../include/t100_hash.h"
#include "../macro/t100.m"
#include "../include/global.h"
#include "../include/t100_block1.h"
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>

int sock,sock2;
sockaddr_in address,address2;
char Flag;
int server_result;

#define HAVE_FTP

#ifdef HAVE_FTP 
//******************************************************************************************************
int t100ftp_pasv(bool output = 1) {
	char buffer[1024],*forany,*splitter[6];
	int splitresult;
	
	send(sock,"PASV\n",5,0);
	bzero(buffer,1024);
	recv(sock,buffer,1023,0);
	
	if(output) printf("%s",buffer);
	sscanf(buffer,"%d",&server_result);
	if(server_result != 227) { fprintf(MYERROR,"%s",buffer); return 0; }
	forany = strchr(buffer,')');
	forany[0] = 0;
	forany = strchr(buffer,'(');
	forany++;
	
	splitresult = split(forany,",",splitter,6);
	if(splitresult < 6) fprintf(MYERROR,"%s","Result incorrect !\n");
	((char *) &address2.sin_port)[0] = atoi(splitter[4]);
	((char *) &address2.sin_port)[1] = atoi(splitter[5]);
	Flag = 0;
	return 0;
}

//*****************************************************************************************************
int t100ftp_sendkomand(char * lpsz_komand,char * lpsz_params = 0) {
	char buffer[1024];
	bzero(buffer,1024);
	STRADD(lpsz_komand);
	if(lpsz_params) { STRADD(" "); STRADD(lpsz_params); }
	STRADD("\r\n");
	return send(sock,buffer,strlen(buffer),0);
}

//******************************************************************************************************
int t100ftp_retr(char * params) {
	char buffer[1024];
	FILE * myfile;
	int int_size;
	
	myfile = fopen(params,"w");
	if(!myfile) { printf("Can't create file here !\n"); return -1; }
	if(0 > connect(sock2,(sockaddr *) &address2,sizeof(address2))) {
		perror("connect");
		fclose(myfile);
		return -1;
	}
	t100ftp_sendkomand("RETR ",params);
	bzero(buffer,1024);
	recv(sock,buffer,1023,0);
	printf("%s",buffer);
	sscanf(buffer,"%d",&server_result);
	if(server_result != 220) fprintf(MYERROR,"%s",buffer);
	while((int_size = recv(sock2,buffer,1024,0)) && (int_size > 0)) {
		fwrite(buffer,1,int_size,myfile);
	}
	fclose(myfile);
	close(sock2);
	sock2 = socket(AF_INET,SOCK_STREAM,0);
	return 0;
}

//*****************************************************************************************************
int t100ftp_stor(char * params) {
	char buffer[1024];
	FILE * myfile;
	int int_size;
	
	if(!params) return -1; 
	myfile = fopen(params,"r");
	if(!myfile) { perror("fopen"); return -1; }
	if(0 > connect(sock2,(sockaddr *) &address2,sizeof(address2))) {
		perror("connect");
		return -1;
	}
	t100ftp_sendkomand("STOR ",params);
	while((int_size = fread(buffer,1,1024,myfile)) && (int_size > 0)) {
		send(sock2,buffer,int_size,0);
	}
	fclose(myfile);
	shutdown(sock2,SHUT_WR);
	close(sock2);
	sock2 = socket(AF_INET,SOCK_STREAM,0);
	return 0;
}

//******************************************************************************************************
//   
char * t100ftp_makestring(char * lpsz_string) {
	char buffer[1024];
	char outbuffer[1024];
	char * forany,*forany2;
	int int_strlen;
	
	int_strlen = strlen(lpsz_string);
	bzero(buffer,1024);
	bzero(outbuffer,1024);
	strncat(buffer,lpsz_string,1023);
	
	forany = buffer;
	forany2 = buffer;
	while((forany2 = strchr(forany,' ')) && (forany2 != 0)) {
		forany2[0] = 0;
		if(strlen(forany) == 0) {
			forany = &forany2[1];
			continue;
		}
		strncat(outbuffer,forany,1023);
		strncat(outbuffer," ",1023);
		forany = &forany2[1];
	}
	strncat(outbuffer,forany,1023);
	return strdup(outbuffer);
}

//******************************************************************************************************
int t100ftp_pass() {
	char * forany;
	forany = getpass("Password for FTP :");
	if(!forany) return -1;
	return t100ftp_sendkomand("PASS",forany); 
}

//******************************************************************************************************
int t100ftp_dumpdir(char * lpsz_dirname,T100ObjectsList * oblist_dirlist,char * lpsz_cols) {
	char buffer[1024];
	char * forany,* buf_mymemfile;
	FILE * mymemfile;
	int int_size;
	unsigned int int_mymemfilesize;
	char buf_maindir[1024];
	int splitresult;
	char * splitter[9];
	char buf_otherdir[1024];
	int i,a;
	
	t100ftp_pasv(0);
	t100ftp_sendkomand("CWD",lpsz_dirname);
//	printf("CWD %s\n",lpsz_dirname);
	bzero(buffer,1024);
	recv(sock,buffer,1023,0);
	sscanf(buffer,"%d",&server_result);
	if(server_result != 250) { fprintf(MYERROR,"%s",buffer); return -1; }
	
	bzero(buf_maindir,1024);
	strcat(buf_maindir,lpsz_dirname);
	if(!lpsz_dirname) return -1; 
	if(0 > connect(sock2,(sockaddr *) &address2,sizeof(address2))) {
		perror("connect");
		return -1;
	}
	
	printf("directory = %s\n",buf_maindir);
	mymemfile = open_memstream(&buf_mymemfile,&int_mymemfilesize);
	
//	printf("%s\n",buffer);
	t100ftp_sendkomand("LIST -aL",0);
	bzero(buffer,1024);
	recv(sock,buffer,1023,0);
	//sscanf(buffer,"%d",&server_result);
	//if(server_result > 300) { fprintf(MYERROR,"List error ! %s",buffer); return - 1; }
	//printf("%s\n",buffer);
	bzero(buffer,1024);
	while((int_size = recv(sock2,buffer,1023,0)) && (int_size > 0)) {
		buffer[1023] = 0;
		fwrite(buffer,1,int_size,mymemfile);
	}
	
	close(sock2);
	sock2 = socket(AF_INET,SOCK_STREAM,0);
	sleep(1);
	recv(sock,buffer,1024,0);
	
	bzero(buffer,1024);
	while(fgets(buffer,1023,mymemfile)) {
		int_size = strlen(buffer);
		buffer[int_size - 2] = 0;
		forany = t100ftp_makestring(buffer);
		bzero(buffer,1024);
		STRADD(buf_maindir); STRADD(" "); STRADD(forany);
		oblist_dirlist->Add(strdup(buffer));
		bzero(buffer,1024);
		STRADD(forany);
		splitresult = split(buffer," ",splitter,9);
		if(buffer[0] != 'd') {
			if(lpsz_cols) { 
				i = atoi(lpsz_cols);
				while((a = i%10) > 0) {
					printf("%s ",splitter[a-1]);
					i /= 10;
				}
			}
			else printf("%s",forany);
			printf("\n");
		}
		bzero(buffer,1024);
	}
	
	fseek(mymemfile,0,SEEK_SET);
	bzero(buffer,1024);
	while(fgets(buffer,1024,mymemfile)) {
		forany = t100ftp_makestring(buffer);
		bzero(buffer,1024);
		STRADD(forany); free(forany);
		chop(buffer); chop(buffer);
		splitresult = split(buffer," ",splitter,9);
		if(splitresult != 9) return -1;
		if((splitter[0][0] == 'd') && (splitter[8][0] != '.')) {
			bzero(buf_otherdir,1024);
			strcat(buf_otherdir,buf_maindir);
			strcat(buf_otherdir,splitter[8]);
			strcat(buf_otherdir,"/");
			
			t100ftp_dumpdir(buf_otherdir,oblist_dirlist,lpsz_cols);
		}
		bzero(buffer,1024);
	}
	
	fclose(mymemfile);
	free(buf_mymemfile);
	return 0;
}

//******************************************************************************************************
int t100ftp_list(char * params) {
	char buffer[1024];
	char * forany,* buf_mymemfile;
	char * splitter[9];
	int splitresult;
	FILE * mymemfile;
	int int_size,i;
	unsigned int int_mymemfilesize;
	unsigned int a;
	char * lpsz_params;
	
	t100ftp_pasv(1);
	if(params) lpsz_params = params+1; 
	else lpsz_params = 0;
	if(0 > connect(sock2,(sockaddr *) &address2,sizeof(address2))) {
		perror("connect");
		return -1;
	}
	mymemfile = open_memstream(&buf_mymemfile,&int_mymemfilesize);
	send(sock,"LIST -aL\r\n",10,0);
	bzero(buffer,1024);
	recv(sock,buffer,1023,0);
	printf("%s\n",buffer);
	bzero(buffer,1024);
	while((int_size = recv(sock2,buffer,1023,0)) && (int_size > 0)) {
		buffer[1023] = 0;
		fwrite(buffer,1,int_size,mymemfile);
	}
	printf("\n");
	
	bzero(buffer,1024);
	while(fgets(buffer,1023,mymemfile)) {
		int_size = strlen(buffer);
		buffer[int_size - 2] = 0;
		forany = t100ftp_makestring(buffer);
		bzero(buffer,1024);
		strncat(buffer,forany,1023);
		free(forany);
		if(!lpsz_params) {
			printf("%s\n",buffer);
			bzero(buffer,1024);
			continue;
		}
		splitresult = split(buffer," ",splitter,9);
		if(splitresult < 9) {
			printf("Incorrect result !\n");
		}
		else {
			i = atoi(lpsz_params);
			while((a = i%10) > 0) {
				printf("%s ",splitter[a-1]);
				i /= 10;
			}
			printf("\n");
		}
		bzero(buffer,1024);
	}
	
	int int_result;
	buffer[1023] = 0;
	sleep(1);
	while((int_result = recv(sock,buffer,1023,MSG_DONTWAIT)) && (int_result > 0)) {
		buffer[int_result] = 0;
		sscanf(buffer,"%d",&server_result);
		if(server_result != 226) { fprintf(MYERROR,"%s",buffer); return -1; }
		printf(buffer);
	}

	close(sock2);
	sock2 = socket(PF_INET,SOCK_STREAM,0);
	
	fclose(mymemfile);
	free(buf_mymemfile);
	return 0;
}

//******************************************************************************************************
int t100ftp(char * params) {
	char buffer[1024],buffer2[1024];
	char * forany,*forany2;
	T100ObjectsList oblist_listdir;
	int int_result;
	
	if(!params) return 0;
	printf("%s\n",params);
	bzero(buffer,1024);
	
	sock = socket(AF_INET,SOCK_STREAM,0);
	sock2 = socket(AF_INET,SOCK_STREAM,0);
	
	address.sin_port = htons(21);
	address.sin_family = AF_INET;
	gethostbyname(params,&address.sin_addr);
	gethostbyname(params,&address2.sin_addr);
	address2.sin_family = AF_INET;
	
	if(0 > connect(sock,(struct sockaddr *) &address,sizeof(address))) {
		perror("connect");
		return -1;
	}
	
	int_result = recv(sock,buffer,1023,0);
	buffer[int_result] = 0;
	printf(buffer);
	
		
t100ftplabel1:
	while(fgets(buffer,1023,MYINPUT)) {
		Flag = 1;
		// *********** .ftp.pass
		if(!strncmp(buffer,".ftp.pass\n",10)) t100ftp_pass();
		else if(!strncmp(buffer,".ftp.list",9)) { t100ftp_list(strchr(buffer,' '));
			bzero(buffer,1024);
			Flag = 0; }
		else if(!strncmp(buffer,".ftp.stor ",10)) {
			chop(buffer);
			forany = strchr(buffer,' ');
			if(forany) t100ftp_stor(++forany);
			else continue;
		}
		// *********** .ftp.retr
		else if(!strncmp(buffer,".ftp.retr ",10)){
			chop(buffer);
			forany = &buffer[10];
			if(forany[0] == 0) continue;
			t100ftp_retr(forany);
		}
		// ********** .ftp.pasv
		else if(!strcmp(buffer,".ftp.pasv\n")) {
			t100ftp_pasv();
		}
		// ********** .ftp.quit
		else if(!strcmp(buffer,".ftp.quit\n")) {
			send(sock,"QUIT\n",5,0);
			close(sock);
			close(sock2);
			break;
		}
		// ********** .ftp.recv
		else if(!strcmp(buffer,".ftp.recv\n")) {
			bzero(buffer,1024);
			sleep(1);
			if(recv(sock,buffer,1023,MSG_DONTWAIT) > 0) {
				printf("%s",buffer);
			}
			Flag = 0;
		}
		// ********** .ftp.dumpdir
		else if(!strncmp(buffer,".ftp.dumpdir",12)) {
			forany = strchr(buffer,' ');
			if(forany) forany++;
			
			t100ftp_sendkomand("PWD",0);
			recv(sock,buffer2,1023,0);
			sscanf(buffer2,"%d",&server_result);
			if(server_result != 257) { fprintf(MYERROR,"%s\n",buffer2); continue; }
			printf(buffer2);
			forany2 = strchr(buffer2,'\"');
			forany2[0] = 0; forany2++;
			strchr(forany2,'\"')[0] = 0;
			strcat(forany2,"/");
			
			t100ftp_dumpdir(forany2,&oblist_listdir,forany);
		}
		else {
			send(sock,buffer,strlen(buffer),0);
		}
		bzero(buffer,1024);
		if(Flag) {
			sleep(1);
			recv(sock,buffer,1023,MSG_DONTWAIT);
			buffer[1023] = 0;
			printf("%s",buffer);
		}
	}
	if(MYINPUT != stdin) {
		fclose(MYINPUT); MYINPUT = stdin;
		goto t100ftplabel1;
	}
	return 0;
}
#endif

#ifndef HAVE_FTP
int t100ftp(char * params) {
return -1;
}
#endif
